;========================================================================
;                                                                       =
;                         LICALC2 & ROOT2sp v2.4                        =
;                                                                       =
; BASIC Version Written By:  Steven Z       siyu12345@yahoo.com         =
;   ASM Version Written By:  Morgan Davies  morgan@ticalc.org           =
;                                           Morgazum85@Juno.com         =
;                                                                       =
;              Upload Date:  January 21, 2004                           =
;                     Size:  1693 Bytes (LICALC2)                       =
;                             897 Bytes (ROOT2sp)                       =
;                            2706 Bytes (Total)                         =
;               Basic Size:  2590 Bytes (Total)                         =
;                                                                       =
; Information about the source:                                         =
;                                                                       =
;   These two programs are a directo port from the 86 Basic Version,    =
; which is also listed in the ticalc.org archives. The sole purpose of  =
; this code was to simulate the function and all the options available  =
; in the Basic version while keeping the appearance of a Basic file.    =
; The source itself is very messy. I could not compress LICALC2 with    =
; Lite 86 II ecause it calls ROOT2sp from within the code. However      =
; ROOT2sp was compressed and saved around 200 or more bytes on that     =
; file. If anyone has questions about 86 assembly math please feel free =
; to contact me (Morgan) at either of the above e-mail addresses.       =
;                                                                       =
; Special Thanks:                                                       =
;                                                                       =
;   Kirk Meyer   (kirkmeyer@bigfoot.com)                                =
;    For making Lite 86 II, and therefor making 86 ASM programs smaller =
;   Steven Z     (siyu12345@yahoo.com)                                  =
;    For teaching me how to reduce roots, for answereing general        =
;    questions about the program, beta testing, and letting me convert  =
;    his program in the first place!                                    =
;                                                                       =
;========================================================================


#include "ti86asm.inc"
#include "Asm86.h"
#include "Rom86.h"

.plugin lite86;                     ;the ultimate compression rutine, saved 711 bytes

_ioprompt   =$c324
_asap_ind   =$d623
_getcode    =$4068

.org _asm_exec_ram 

    nop                             ;no operation so...
    jp StartupCheck                 ;jump to StartupCheck
    .dw 0                           ;type of input
    .dw String0                     ;print string

StartupCheck:
    call _flushallmenus             ;clears all key codes
    call _runindicoff               ;turn off run indicator
    call _clrScrn                   ;clear screen
    call _homeup                    ;move to upper left
    call Check_Variable1            ;goes to Check_Variable1
    ld a,5                          ;loads a with 5
    call _setXXop2                  ;move value of a(0) to op2
    call _cpop1op2                  ;compare op1 to op2(0)
    jr z,Start
    ld hl,a5
    call Recall_Variable
    ld a,1                          ;loads a with 5
    call _setXXop2                  ;move value of a(0) to op2
    call _cpop1op2                  ;compare op1 to op2(0)
    jr nz,Start
    call _clrScrn                   ;clear screen
    call _homeup                    ;move to upper left
    ld hl,(256*0)+0                 ;loads coordinates into hl, row 1, col 1
    ld (_curRow),hl                 ;loads _curRow with hl
    ld hl,String7                   ;loads hl with string
    call _puts                      ;print string
    call _newline
    ld hl,a1
    call Recall_Variable
    ld hl,String8
    call _puts
    call DispAnswer
    call _newline
    ld hl,String9
    call _puts
    ld hl,a2
    call Recall_Variable
    call DispAnswer
    call _newline
    jr VariablesExist

Start:
    call _clrScrn                   ;clear screen
    call Check_Variable2
    ld hl,(256*0)+0                 ;loads coordinates into hl, row 1, col 1
    ld (_curRow),hl                 ;loads _curRow with hl
    ld hl,String0                   ;loads hl with string
    call _puts                      ;print string
    call _newline
    call _puts
    call _newline
    ld hl,String3
    call Input
    call _op1toop3
    ld hl,a1                        ;variable name to store op2 to
    call Create_Variable            ;creates real variable hl with op2
Same_Index_Different_Root:
    call _clrScrn                   ;clear screen
    call _homeup                    ;move to upper left
    ld hl,(256*0)+0                 ;loads coordinates into hl, row 1, col 1
    ld (_curRow),hl                 ;loads _curRow with hl
    ld hl,String7                   ;loads hl with string
    call _puts                      ;print string
    call _newline
    ld hl,a1
    call Recall_Variable
    ld hl,String8
    call _puts
    call DispAnswer
    call _newline
    ld hl,String9
    call Input
    call _op1toop3
    ld hl,a2                        ;variable name to store op2 to
    call Create_Variable            ;creates real variable hl with op2
    ld hl,a2
    call Recall_Variable
VariablesExist:
    call _INTGR
    rst 08h
    ld hl,a2
    call Recall_Variable
    call _FPSUB
    call _op1toop3
    ld hl,a6
    call Create_Variable
    ld hl,a6
    call Recall_Variable
    xor a                           ;loads a with 0
    call _setXXop2                  ;move value of a(0) to op2
    call _cpop1op2                  ;compare op1 to op2(0)
    jp nz,Fraction_Is_Not_Zero      ;goes to Fraction_Is_Not_Zero if they are both "0"
    ld hl,a1
    call Recall_Variable
    rst 08h
    ld a,1
    call _setXXop1
    call _FPDIV
    rst 08h
    ld hl,a2
    call Recall_Variable
    call _YTOX
    ld d,11
    call _ROUND
    call _INTGR
    call _op1toop3
    ld hl,a3
    call Create_Variable
    ld hl,a3
    call Recall_Variable
    call _absop2
    call _op1toop3
    ld hl,a4
    call Create_Variable
For_Loop:
    ld hl,a4
    call Recall_Variable
    ld a,1                          ;loads a with 1
    call _setXXop2                  ;move value of a(1) to op2
    call _cpop1op2                  ;compare op1 to op2(0)
    jr z,Loop_Complete
    ld hl,a1
    call Recall_Variable
    rst 08h
    ld hl,a4
    call Recall_Variable
    call _YTOX
    call _op1toop6
    ld hl,a2
    call Recall_Variable
    call _op6toop2
    call _FPDIV
    call _op1toop4
    call _INTGR
    rst 08h
    call _op4toop1
    call _FPSUB
    call _op6toop2
    rst 28h                     ;OP1 == mod(B,D^A)
;    call _INTGR
    xor a                           ;loads a with 1
    call _setXXop2                  ;move value of a(1) to op2
    call _cpop1op2                  ;compare op1 to op2(0)
    jr z,Loop_Complete
    ld hl,a4
    call Recall_Variable
    call _MINUS1
    call _op1toop4
    ld hl,a4
    rst 20h
    rst 10h
    call _delvar
    call _op4toop3
    ld hl,a4
    call Create_Variable
    jr For_Loop

Loop_Complete:
    ld hl,a5
    call Recall_Variable
    ld a,1
    call _setXXop2
    call _cpop1op2                  ;compare op1 to op2(0)
    jp z,Return_To_LICALC2
    ld hl,a4
    call Recall_Variable
    ld hl,String11
    call _puts
    call DispAnswer
    ld hl,a1
    call Recall_Variable
    rst 08h
    ld hl,a4
    call Recall_Variable
    call _YTOX
    call _op1toop6
    ld hl,a2
    call Recall_Variable
    call _op6toop2
    call _FPDIV
    ld hl,String10
    call _puts
    call DispAnswer
fPart_Is_A_Decimal:
    call _newline
    ld hl,a1
    call Recall_Variable
    rst 08h
    ld a,1
    call _setXXop1
    call _FPDIV
    rst 08h
    ld hl,a2
    call Recall_Variable
    call _YTOX
    ld hl,String11
    call _puts
    call DispAnswer
    ld hl,String4                   ;string to print
    ld bc,256*58+5                  ;column 5, row 59
    ld (_penCol),bc                 ;loads c into _penCol
                                    ;  and b into _penRow
    call _vputs                     ;print it and return
    ld hl,String5                   ;string to print
    ld bc,256*58+55                 ;column 5, row 59
    ld (_penCol),bc                 ;loads c into _penCol
                                    ;  and b into _penRow
    call _vputs                     ;print it and return
    ld hl,String6                   ;string to print
    ld bc,256*58+107                ;column 5, row 59
    ld (_penCol),bc                 ;loads c into _penCol
                                    ;  and b into _penRow
    call _vputs                     ;print it and return
    call MenuRoutine1               ;goes to MenuRoutine2
GetKey:
    call _getcode                   ;stores key pressed into a
    cp K_EXIT                       ;compares a with Exit
    jp z,Exit                       ;if Exit jump to Exit
    cp K_ALPHA                      ;compares a to Alpha
    call z,CalcOff                  ;if Alpha jump to CalcOff
    cp K_F1                         ;compares a with F1 key
    jr z,Again                       ;if F1 jump to Again
    cp K_F3                         ;compares a with F3 key
    jp z,Start                      ;if F2 jump to Start
    cp K_F5                         ;compares a with F5 key
    jp z,Exit                       ;if F4 jump to Exit
    jr GetKey                       ;jumps to GetKey

Return_To_LICALC2:
    ret

Fraction_Is_Not_Zero:
    ld a,1
    call _setXXop2
    call _op2toop3
    ld hl,a4
    call Create_Variable
    ld a,1
    call _setXXop1
    ld hl,String11
    call _puts
    call DispAnswer
    ld hl,a2
    call Recall_Variable
    ld hl,String10
    call _puts
    call DispAnswer
    jp fPart_Is_A_Decimal

Again:
    ld hl,a2
    rst 20h
    rst 10h;call _findsym
    call _delvar
    ld hl,a3
    rst 20h
    rst 10h;call _findsym
    call _delvar
    ld hl,a4
    rst 20h
    rst 10h;call _findsym
    call _delvar
    jp Same_Index_Different_Root

Check_Variable1:
    ld hl,a1
    call Find_Variable
    ld hl,a2
    call Find_Variable
    ld hl,a5
Find_Variable:
    rst 20h
    rst 10h;call _findsym
    jr c,Not_On_Calc1
    jr Real_Variable
Not_On_Calc1:
    ld a,5
    call _setXXop1
    ret
Real_Variable:
    ret

Check_Variable2:
    ld hl,a1
    call Delete_Variable
    ld hl,a2
    call Delete_Variable
    ld hl,a3
    call Delete_Variable
    ld hl,a4
    call Delete_Variable
    ld hl,a5
    call Delete_Variable
    ld hl,a6
Delete_Variable:
    rst 20h
    rst 10h;call _findsym
    jr c,Not_On_Calc2
    call _delvar
Not_On_Calc2:
    ret

Create_Variable:
    rst 20h
    rst 10h
    jr c,NewVariable
    call _delvar
NewVariable:
    call _createreal
    ex de,hl
    ld a,b
    call _set_abs_dest_addr
    ld hl,_OP3
    xor a
    call _set_abs_src_addr
    jr Loop_Variable

Recall_Variable:
    rst 20h                         ; ld (op1) with (hl)
    rst 10h;call _findsym                   ; is there a variable 'inFrac'?
    ex de,hl
    ld a,b
    call _set_abs_src_addr
    ld hl,_OP1
    xor a
    call _set_abs_dest_addr
Loop_Variable:
    ld hl,10
    xor a
    call _set_mm_num_bytes
    call _mm_ldir
    ret

DispAnswer:
    ld a,48                         ;loads a with 48
    call _formReal                  ;forms answer to real #
    ld hl,_OP3                      ;loads answer into hl
    call _puts                      ;prints answer
    call _runindicoff               ;turn off run indicator
    ret

Input:
    ld de,_ioprompt                 ;$c324 - string storage for display when prompte
    call _mov10b                    ;$427b - move 10 bytes from hl to de
    ld a,$0d                        ;type of input
                                    ;$0d - # value
                                    ;$0c - string
    ld (_asap_ind),a                ;$d623 - tell ti86 what kind to be inputted
    jp _exec_pg3                    ;$5714 - ti86 os input
                                    ;the number input is always stored to OP1
    ret                             ;return to call

CalcOff:
    ld a,1
    out (3),a
    halt
    ld a,11
    out (3),a        
    res onInterrupt,(iy+onflags)
    ret

Exit:
    call Check_Variable2
    call _clrScrn                   ;clears the screen
    call _homeup                    ;moves cursor to upper left
    call _dispDone                  ;makes it appear like more of a clean exit :-)
    call _jforcecmdnochar           ;normal 'ret' comes up with an error, had to use this

#include "Menu86.asm"

String0:    .db "ROOT2",0
String1:    .db "Hectosoft, Inc.",0
String2:    .db "The program LICALC2  is not on your calc!",0
String3:    .db "Index=",0
String4:    .db "again",0
String5:    .db "reset",0
String6:    .db "exit",0
String7:    .db 205,16,"y",0
String8:    .db 5,"x=",0
String9:    .db 5,"y=",0
String10:   .db 205,16,0
String11:   .db 208,0
String12:   .db "Good Bye!=",0

LICALC2:    .db 7,"LICALC2",0

a1: .db $12
    .db 1,"A",0
a2: .db $12
    .db 1,"B",0
a3: .db $12
    .db 1,"C",0
a4: .db $12
    .db 1,"D",0
a5: .db $12
    .db 5,"SHELL",0
a6: .db $12
    .db 5,"iFrac",0

.end
END